﻿using DressAtelierContracts.BindingModels;
using DressAtelierContracts.ViewModels;
using DressAtelierDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DressAtelierDatabaseImplement.Models
{
    public class MessageInfo : IMessageInfoModel
    {

        public string ID { get; private set; } = string.Empty;

        public int? ClientID { get; private set; }

        public string SenderName { get; private set; } = string.Empty;
        public DateTime DeliveryDate { get; private set; }

        public string Subject { get; private set; } = string.Empty;

        public string Body { get; private set; } = string.Empty;

        public virtual Client? Client { get; private set; }

        public static MessageInfo? Create(MessageInfoBindingModel model)
        {
            if(model == null)
            {
                return null;
            }
            return new MessageInfo
            {
                ID = model.ID,
                ClientID = model.ClientID,
                SenderName = model.SenderName,
                Body = model.Body,
                DeliveryDate = model.DeliveryDate,
                Subject = model.Subject,
            };
        }

        public MessageInfoViewModel GetViewModel => new()
        {
            ID = ID,
            ClientID = ClientID,
            SenderName = SenderName,
            Body = Body,
            DeliveryDate = DeliveryDate,
            Subject = Subject,
        };
    }
}
