﻿using DressAtelierContracts.BindingModels;
using DressAtelierContracts.ViewModels;
using DressAtelierDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DressAtelierListImplement.Models
{
    public class MessageInfo : IMessageInfoModel
    {
        public string ID { get; set; } = string.Empty;

        public int? ClientID { get; set; }

        public string SenderName { get; set; } = string.Empty;

        public DateTime DeliveryDate { get; set; }

        public string Subject { get; set; } = string.Empty;

        public string Body { get; set; } = string.Empty;

        public static MessageInfo? Create(MessageInfoBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new()
            {
                ID = model.ID,
                SenderName = model.SenderName,
                DeliveryDate = model.DeliveryDate,
                Subject = model.Subject,
                Body = model.Body,
            };
        }

        public MessageInfoViewModel GetViewModel => new()
        {
            ID = ID,
            SenderName = SenderName,
            DeliveryDate = DeliveryDate,
            Subject = Subject,
            Body = Body
        };
    }
}
