﻿using DressAtelierContracts.BusinessLogicContracts;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SewingDresses
{
    public partial class FormEmails : Form
    {
        private readonly ILogger _logger;
        private readonly IMessageInfoLogic _logic;

        public FormEmails(ILogger<FormEmails> logger, IMessageInfoLogic logic)
        {
            InitializeComponent();
            _logger = logger;
            _logic = logic;
        }

        private void FormEmails_Load(object sender, EventArgs e)
        {
            LoadData();
        }

        private void LoadData()
        {
            try
            {
                var list = _logic.ReadList(null);
                if (list != null)
                {
                    emailsGridView.DataSource = list;
                    emailsGridView.Columns["ClientID"].Visible = false;
                    emailsGridView.Columns["ID"].Visible = false;
                    emailsGridView.Columns["Body"].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
                }
                _logger.LogInformation("Loading materials");
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Error loading materials");
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
